de.caff.generics

## Class RefWrapperList<V>

- java.lang.Object
- - de.caff.generics.RefWrapperList<V>

- All Implemented Interfaces:
    java.lang.Iterable<V>, java.util.Collection<V>, java.util.List<V>

      public class RefWrapperList<V>
      extends java.lang.Object
      implements java.util.List<V>

  A list which holds its elements as references. The list will be automatically cleaned up when an iterator is constructed.
  Author:
    Rammi

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `RefWrapperList(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator)` Default constructor.
    `` | `RefWrapperList(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, java.util.Collection<? extends V> c)` Create a reference wrapper list from a collection.
    `protected` | `RefWrapperList(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, java.util.List<java.lang.ref.Reference<V>> wrappedList)` Constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(int index, V element)` Inserts the specified element at the specified position in this list (optional operation).
    `boolean` | `add(V o)` Appends the specified element to the end of this list (optional operation).
    `boolean` | `addAll(java.util.Collection<? extends V> c)` Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified collection's iterator (optional operation).
    `boolean` | `addAll(int index, java.util.Collection<? extends V> c)` Inserts all of the elements in the specified collection into this list at the specified position (optional operation).
    `void` | `clear()` Removes all of the elements from this list (optional operation).
    `boolean` | `contains(java.lang.Object o)` Returns `true` if this list contains the specified element.
    `boolean` | `containsAll(java.util.Collection<?> c)` Returns `true` if this list contains all of the elements of the specified collection.
    `static <W> RefWrapperList<W>` | `create(ReferenceCreator<? extends java.lang.ref.Reference<W>,W> creator, java.util.List<java.lang.ref.Reference<W>> baseList)` Factory method which allows to define a given underlying list.
    `V` | `get(int index)` Returns the element at the specified position in this list.
    `int` | `indexOf(java.lang.Object o)` Returns the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element.
    `boolean` | `isEmpty()` Returns `true` if this list contains no elements.
    `java.util.Iterator<V>` | `iterator()` Returns an iterator over the elements in this list in proper sequence.
    `int` | `lastIndexOf(java.lang.Object o)` Returns the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element.
    `java.util.ListIterator<V>` | `listIterator()` Returns a list iterator of the elements in this list (in proper sequence).
    `java.util.ListIterator<V>` | `listIterator(int index)` Returns a list iterator of the elements in this list (in proper sequence), starting at the specified position in this list.
    `V` | `remove(int index)` Removes the element at the specified position in this list (optional operation).
    `boolean` | `remove(java.lang.Object o)` Removes the first occurrence in this list of the specified element (optional operation).
    `boolean` | `removeAll(java.util.Collection<?> c)` Removes from this list all the elements that are contained in the specified collection (optional operation).
    `boolean` | `retainAll(java.util.Collection<?> c)` Retains only the elements in this list that are contained in the specified collection (optional operation).
    `V` | `set(int index, V element)` Replaces the element at the specified position in this list with the specified element (optional operation).
    `int` | `size()` Returns the number of elements in this list.
    `java.util.List<V>` | `subList(int fromIndex, int toIndex)` Returns a view of the portion of this list between the specified `fromIndex`, inclusive, and `toIndex`, exclusive.
    `java.lang.Object[]` | `toArray()` Returns an array containing all of the elements in this list in proper sequence.
    `<T> T[]` | `toArray(T[] a)` Returns an array containing all of the elements in this list in proper sequence; the runtime type of the returned array is that of the specified array.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.List

      `equals, hashCode, replaceAll, sort, spliterator`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

- - ### Constructor Detail

    - #### RefWrapperList

          public RefWrapperList(@NotNull
                                ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator)

      Default constructor. This will use a wrapped linked list.
      Parameters:
        `creator` - reference creator used to create the internally stored references

    - #### RefWrapperList

          public RefWrapperList(@NotNull
                                ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                java.util.Collection<? extends V> c)

      Create a reference wrapper list from a collection. This will use a wrapped linked list.
      Parameters:
        `creator` - reference creator used to create the internally stored references
        `c` - collection the collection elements will be wrapped in the given reference type and added to this list

    - #### RefWrapperList

          protected RefWrapperList(@NotNull
                                   ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                   @NotNull
                                   java.util.List<java.lang.ref.Reference<V>> wrappedList)

      Constructor. This allows to define a dedicated underlying list. As this wrapper has to have complete control of this list it should not be used elsewhere.
      Parameters:
        `creator` - reference creator used to create the internally stored references
        `wrappedList` - wrapped list

  - ### Method Detail

    - #### size

          public int size()

      Returns the number of elements in this list. If this list contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.
      Specified by:
        `size` in interface `java.util.Collection<V>`
      Specified by:
        `size` in interface `java.util.List<V>`
      Returns:
        the number of elements in this list.

    - #### isEmpty

          public boolean isEmpty()

      Returns `true` if this list contains no elements.
      Specified by:
        `isEmpty` in interface `java.util.Collection<V>`
      Specified by:
        `isEmpty` in interface `java.util.List<V>`
      Returns:
        `true` if this list contains no elements.

    - #### contains

          public boolean contains(java.lang.Object o)

      Returns `true` if this list contains the specified element. More formally, returns `true` if and only if this list contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.
      Specified by:
        `contains` in interface `java.util.Collection<V>`
      Specified by:
        `contains` in interface `java.util.List<V>`
      Parameters:
        `o` - element whose presence in this list is to be tested.
      Returns:
        `true` if this list contains the specified element.
      Throws:
        `java.lang.ClassCastException` - if the type of the specified element is incompatible with this list (optional).
        `java.lang.NullPointerException` - if the specified element is null and this list does not support null elements (optional).

    - #### iterator

          @NotNull
          public java.util.Iterator<V> iterator()

      Returns an iterator over the elements in this list in proper sequence.
      Specified by:
        `iterator` in interface `java.lang.Iterable<V>`
      Specified by:
        `iterator` in interface `java.util.Collection<V>`
      Specified by:
        `iterator` in interface `java.util.List<V>`
      Returns:
        an iterator over the elements in this list in proper sequence.

    - #### toArray

          @NotNull
          public java.lang.Object[] toArray()

      Returns an array containing all of the elements in this list in proper sequence. Obeys the general contract of the `Collection.toArray` method.
      Specified by:
        `toArray` in interface `java.util.Collection<V>`
      Specified by:
        `toArray` in interface `java.util.List<V>`
      Returns:
        an array containing all of the elements in this list in proper sequence.
      See Also:
        `Arrays.asList(Object[])`

    - #### toArray

          @NotNull
          public <T> T[] toArray(@NotNull
                                          T[] a)

      Returns an array containing all of the elements in this list in proper sequence; the runtime type of the returned array is that of the specified array. Obeys the general contract of the `Collection.toArray(Object[])` method.
      Specified by:
        `toArray` in interface `java.util.Collection<V>`
      Specified by:
        `toArray` in interface `java.util.List<V>`
      Parameters:
        `a` - the array into which the elements of this list are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
      Returns:
        an array containing the elements of this list.
      Throws:
        `java.lang.ArrayStoreException` - if the runtime type of the specified array is not a supertype of the runtime type of every element in this list.
        `java.lang.NullPointerException` - if the specified array is `null`.

    - #### add

          public boolean add(V o)

      Appends the specified element to the end of this list (optional operation).

      Lists that support this operation may place limitations on what elements may be added to this list. In particular, some lists will refuse to add null elements, and others will impose restrictions on the type of elements that may be added. List classes should clearly specify in their documentation any restrictions on what elements may be added.

      Specified by:
        `add` in interface `java.util.Collection<V>`
      Specified by:
        `add` in interface `java.util.List<V>`
      Parameters:
        `o` - element to be appended to this list.
      Returns:
        `true` (as per the general contract of the `Collection.add` method).
      Throws:
        `java.lang.UnsupportedOperationException` - if the `add` method is not supported by this list.
        `java.lang.ClassCastException` - if the class of the specified element prevents it from being added to this list.
        `java.lang.NullPointerException` - if the specified element is null and this list does not support null elements.
        `java.lang.IllegalArgumentException` - if some aspect of this element prevents it from being added to this list.

    - #### remove

          public boolean remove(java.lang.Object o)

      Removes the first occurrence in this list of the specified element (optional operation). If this list does not contain the element, it is unchanged. More formally, removes the element with the lowest index i such that `(o==null ? get(i)==null : o.equals(get(i)))` (if such an element exists).
      Specified by:
        `remove` in interface `java.util.Collection<V>`
      Specified by:
        `remove` in interface `java.util.List<V>`
      Parameters:
        `o` - element to be removed from this list, if present.
      Returns:
        `true` if this list contained the specified element.
      Throws:
        `java.lang.ClassCastException` - if the type of the specified element is incompatible with this list (optional).
        `java.lang.NullPointerException` - if the specified element is null and this list does not support null elements (optional).
        `java.lang.UnsupportedOperationException` - if the `remove` method is not supported by this list.

    - #### containsAll

          public boolean containsAll(@NotNull
                                     java.util.Collection<?> c)

      Returns `true` if this list contains all of the elements of the specified collection.
      Specified by:
        `containsAll` in interface `java.util.Collection<V>`
      Specified by:
        `containsAll` in interface `java.util.List<V>`
      Parameters:
        `c` - collection to be checked for containment in this list.
      Returns:
        `true` if this list contains all of the elements of the specified collection.
      Throws:
        `java.lang.ClassCastException` - if the types of one or more elements in the specified collection are incompatible with this list (optional).
        `java.lang.NullPointerException` - if the specified collection contains one or more null elements and this list does not support null elements (optional); or if the specified collection is `null`.
      See Also:
        `contains(Object)`

    - #### addAll

          public boolean addAll(@NotNull
                                java.util.Collection<? extends V> c)

      Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified collection's iterator (optional operation). The behavior of this operation is unspecified if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.)
      Specified by:
        `addAll` in interface `java.util.Collection<V>`
      Specified by:
        `addAll` in interface `java.util.List<V>`
      Parameters:
        `c` - collection whose elements are to be added to this list.
      Returns:
        `true` if this list changed as a result of the call.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `addAll` method is not supported by this list.
        `java.lang.ClassCastException` - if the class of an element in the specified collection prevents it from being added to this list.
        `java.lang.NullPointerException` - if the specified collection contains one or more null elements and this list does not support null elements, or if the specified collection is `null`.
        `java.lang.IllegalArgumentException` - if some aspect of an element in the specified collection prevents it from being added to this list.
      See Also:
        `add(Object)`

    - #### addAll

          public boolean addAll(int index,
                                @NotNull
                                java.util.Collection<? extends V> c)

      Inserts all of the elements in the specified collection into this list at the specified position (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in this list in the order that they are returned by the specified collection's iterator. The behavior of this operation is unspecified if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.)
      Specified by:
        `addAll` in interface `java.util.List<V>`
      Parameters:
        `index` - index at which to insert first element from the specified collection.
        `c` - elements to be inserted into this list.
      Returns:
        `true` if this list changed as a result of the call.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `addAll` method is not supported by this list.
        `java.lang.ClassCastException` - if the class of one of elements of the specified collection prevents it from being added to this list.
        `java.lang.NullPointerException` - if the specified collection contains one or more null elements and this list does not support null elements, or if the specified collection is `null`.
        `java.lang.IllegalArgumentException` - if some aspect of one of elements of the specified collection prevents it from being added to this list.
        `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size()).

    - #### removeAll

          public boolean removeAll(@NotNull
                                   java.util.Collection<?> c)

      Removes from this list all the elements that are contained in the specified collection (optional operation).
      Specified by:
        `removeAll` in interface `java.util.Collection<V>`
      Specified by:
        `removeAll` in interface `java.util.List<V>`
      Parameters:
        `c` - collection that defines which elements will be removed from this list.
      Returns:
        `true` if this list changed as a result of the call.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `removeAll` method is not supported by this list.
        `java.lang.ClassCastException` - if the types of one or more elements in this list are incompatible with the specified collection (optional).
        `java.lang.NullPointerException` - if this list contains one or more null elements and the specified collection does not support null elements (optional); or if the specified collection is `null`.
      See Also:
        `remove(Object)`, `contains(Object)`

    - #### retainAll

          public boolean retainAll(@NotNull
                                   java.util.Collection<?> c)

      Retains only the elements in this list that are contained in the specified collection (optional operation). In other words, removes from this list all the elements that are not contained in the specified collection.
      Specified by:
        `retainAll` in interface `java.util.Collection<V>`
      Specified by:
        `retainAll` in interface `java.util.List<V>`
      Parameters:
        `c` - collection that defines which elements this set will retain.
      Returns:
        `true` if this list changed as a result of the call.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `retainAll` method is not supported by this list.
        `java.lang.ClassCastException` - if the types of one or more elements in this list are incompatible with the specified collection (optional).
        `java.lang.NullPointerException` - if this list contains one or more null elements and the specified collection does not support null elements (optional); or if the specified collection is `null`.
      See Also:
        `remove(Object)`, `contains(Object)`

    - #### clear

          public void clear()

      Removes all of the elements from this list (optional operation). This list will be empty after this call returns (unless it throws an exception).
      Specified by:
        `clear` in interface `java.util.Collection<V>`
      Specified by:
        `clear` in interface `java.util.List<V>`
      Throws:
        `java.lang.UnsupportedOperationException` - if the `clear` method is not supported by this list.

    - #### get

          public V get(int index)

      Returns the element at the specified position in this list.
      Specified by:
        `get` in interface `java.util.List<V>`
      Parameters:
        `index` - index of element to return.
      Returns:
        the element at the specified position in this list.
      Throws:
        `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

    - #### set

          public V set(int index,
                       V element)

      Replaces the element at the specified position in this list with the specified element (optional operation).
      Specified by:
        `set` in interface `java.util.List<V>`
      Parameters:
        `index` - index of element to replace.
        `element` - element to be stored at the specified position.
      Returns:
        the element previously at the specified position.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `set` method is not supported by this list.
        `java.lang.ClassCastException` - if the class of the specified element prevents it from being added to this list.
        `java.lang.NullPointerException` - if the specified element is null and this list does not support null elements.
        `java.lang.IllegalArgumentException` - if some aspect of the specified element prevents it from being added to this list.
        `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

    - #### add

          public void add(int index,
                          V element)

      Inserts the specified element at the specified position in this list (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).
      Specified by:
        `add` in interface `java.util.List<V>`
      Parameters:
        `index` - index at which the specified element is to be inserted.
        `element` - element to be inserted.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `add` method is not supported by this list.
        `java.lang.ClassCastException` - if the class of the specified element prevents it from being added to this list.
        `java.lang.NullPointerException` - if the specified element is null and this list does not support null elements.
        `java.lang.IllegalArgumentException` - if some aspect of the specified element prevents it from being added to this list.
        `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size()).

    - #### remove

          public V remove(int index)

      Removes the element at the specified position in this list (optional operation). Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the list.
      Specified by:
        `remove` in interface `java.util.List<V>`
      Parameters:
        `index` - the index of the element to removed.
      Returns:
        the element previously at the specified position.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `remove` method is not supported by this list.
        `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

    - #### indexOf

          public int indexOf(java.lang.Object o)

      Returns the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element. More formally, returns the lowest index `i` such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.
      Specified by:
        `indexOf` in interface `java.util.List<V>`
      Parameters:
        `o` - element to search for.
      Returns:
        the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element.
      Throws:
        `java.lang.ClassCastException` - if the type of the specified element is incompatible with this list (optional).
        `java.lang.NullPointerException` - if the specified element is null and this list does not support null elements (optional).

    - #### lastIndexOf

          public int lastIndexOf(java.lang.Object o)

      Returns the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element. More formally, returns the highest index `i` such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.
      Specified by:
        `lastIndexOf` in interface `java.util.List<V>`
      Parameters:
        `o` - element to search for.
      Returns:
        the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element.
      Throws:
        `java.lang.ClassCastException` - if the type of the specified element is incompatible with this list (optional).
        `java.lang.NullPointerException` - if the specified element is null and this list does not support null elements (optional).

    - #### listIterator

          @NotNull
          public java.util.ListIterator<V> listIterator()

      Returns a list iterator of the elements in this list (in proper sequence).
      Specified by:
        `listIterator` in interface `java.util.List<V>`
      Returns:
        a list iterator of the elements in this list (in proper sequence).

    - #### listIterator

          @NotNull
          public java.util.ListIterator<V> listIterator(int index)

      Returns a list iterator of the elements in this list (in proper sequence), starting at the specified position in this list. The specified index indicates the first element that would be returned by an initial call to the `next` method. An initial call to the `previous` method would return the element with the specified index minus one.
      Specified by:
        `listIterator` in interface `java.util.List<V>`
      Parameters:
        `index` - index of first element to be returned from the list iterator (by a call to the `next` method).
      Returns:
        a list iterator of the elements in this list (in proper sequence), starting at the specified position in this list.
      Throws:
        `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size()).

    - #### subList

          @NotNull
          public java.util.List<V> subList(int fromIndex,
                                                    int toIndex)

      Returns a view of the portion of this list between the specified `fromIndex`, inclusive, and `toIndex`, exclusive. (If `fromIndex` and `toIndex` are equal, the returned list is empty.) The returned list is backed by this list, so non-structural changes in the returned list are reflected in this list, and vice-versa. The returned list supports all of the optional list operations supported by this list.

      This method eliminates the need for explicit range operations (of the sort that commonly exist for arrays). Any operation that expects a list can be used as a range operation by passing a subList view instead of a whole list. For example, the following idiom removes a range of elements from a list:

                      list.subList(from, to).clear();

      Similar idioms may be constructed for `indexOf` and `lastIndexOf`, and all of the algorithms in the `Collections` class can be applied to a subList.

      The semantics of the list returned by this method become undefined if the backing list (i.e., this list) is structurally modified in any way other than via the returned list. (Structural modifications are those that change the size of this list, or otherwise perturb it in such a fashion that iterations in progress may yield incorrect results.)

      Specified by:
        `subList` in interface `java.util.List<V>`
      Parameters:
        `fromIndex` - low endpoint (inclusive) of the subList.
        `toIndex` - high endpoint (exclusive) of the subList.
      Returns:
        a view of the specified range within this list.
      Throws:
        `java.lang.IndexOutOfBoundsException` - for an illegal endpoint index value (fromIndex < 0 || toIndex > size || fromIndex > toIndex).

    - #### create

          public static <W> RefWrapperList<W> create(@NotNull
                                                     ReferenceCreator<? extends java.lang.ref.Reference<W>,W> creator,
                                                     @NotNull
                                                     java.util.List<java.lang.ref.Reference<W>> baseList)

      Factory method which allows to define a given underlying list. This allows to define a dedicated underlying list. As this wrapper has to have complete control of this list it should not be used elsewhere. The recommended way of invoking this constructor is (e.g. for ArrayList)

      >        refWrapperList =
      >           RefWrapperList.create(ReferenceUtil.getSoftReferenceCreator
      >                                 new ArrayList<Reference<XY>>());
      >      }

      Type Parameters:
        `W` - value type
      Parameters:
        `creator` - reference creator
        `baseList` - basic list
      Returns:
        reference wrapper list based on baseList